/* -------------------------------------------------------------------------*
 * Samples for the Attolic True Studio and the GCC                          *
 * Copyright (C) Lucjan Bryndza <lucjan.bryndza@ep.com.pl>  19.11.2010      *
 * Example No1 for the STM32 Butterfly2 and KamodLED8                       *
 * Simple light effect on the LEDS. KamodLED8 D0-D7 lines should be         *
 * connected to the PE0-PE7 on the STM32Butterfly board                     *
 * http://www.boff.pl                                                       *
 * -------------------------------------------------------------------------*/

#include "stm32f10x_lib.h"
#include "system.h"
#include <stdbool.h>

#define LEDS_PORT GPIOE
#define LEDS_BITS 0xff
#define LED_PORT_APB2 RCC_APB2Periph_GPIOE

#define DELAY_LOOP_CYCLES 1000000
/* ----------------------------------------------------------------------- */
int main(void)
{
    //Enable PE in APB2
    RCC->APB2ENR |= LED_PORT_APB2;
    //LED as output
    io_config_ext(LEDS_PORT,LEDS_BITS,GPIO_MODE_10MHZ,GPIO_CNF_GPIO_PP);

    //main loop
    while(true)
    {
        for(unsigned b=1; b<0x100; b=b<<1)
        {
            io_set_clr_mask(LEDS_PORT, b, LEDS_BITS );
            for(int i=0;i<DELAY_LOOP_CYCLES;i++) nop();
        }
    }
    return 0;
}
/* ----------------------------------------------------------------------- */

